## boot-floppies 3.0.22

=== Makefile ===
# Top-level Makefile for boot-floppies
#   see README* for information

# @@ Marcel FIXME: resc*.bin target for i386 make both resc*.bin and root*.bin:
#                  update scripts and clean make rules

all::	build

# Configurable variables reside in the config file.
# Note: see README for notes on how to build boot-floppies for just one language.
include config

# common variables
include make/vars

# architecture-specific variables
-include make/$(architecture).vars

# documentation rules live in documentation/Makefile*
include documentation/Makefile.docs

# i18n stuff -- must come after arch stuff
include make/i18n

# shell needs to be set to base for the release target, at least
SHELL = bash

# [ED] avoid direct compilation of C programs from the utilities subdir
# (see the root.bin dependencies).  BTW utils target does the right job.
.SUFFIXES:

null:
	: Null target for testing Makefile with "make -p null"

#---------------------------------------------------------------------------

localfiles:: updates
	set -e; \
	if [ -d $(incoming) ]; then \
	    cd $(incoming) ;\
	    find . -name '*_all.deb' -exec cp {} $(CURDIR)/updates/ \; ;\
	    find . -name '*_$(architecture).deb' -exec cp {} $(CURDIR)/updates/ \; ;\
	fi
	set -e; \
	if [ -d $(local_dir) ]; then \
	    cd $(local_dir) ;\
	    find . -name '*.deb' -exec cp {} $(CURDIR)/updates/ \; ;\
	fi
#	 it is better for the apt-get archives to be owned by user, not root
	[ -d $(archive) ] || mkdir -p $(archive)
	[ -d $(tmpdir)/boot-floppies ] || mkdir -p $(tmpdir)/boot-floppies

# dependency for the files that have to be copied
updates::
	[ -d updates ] || mkdir -p updates

build::	localfiles
	$(MAKE) utils
ifeq ($(architecture), i386)
	i18n_low_space=true make resc1200.bin resc1200-s.bin
	$(MAKE) resc1440.bin resc1440-s.bin
	$(MAKE) resc1440compact.bin
	$(MAKE) resc1440idepci.bin
	$(MAKE) resc1440bf2.4.bin
	$(MAKE) drivers.tgz
	$(MAKE) driverscompact.tgz
	$(MAKE) driversidepci.tgz
	$(MAKE) driversbf2.4.tgz
	$(MAKE) resc2880.bin
	$(MAKE) resc2880compact.bin
	$(MAKE) resc2880idepci.bin
	$(MAKE) resc2880bf2.4.bin
	$(MAKE) tftpboot.img
	$(MAKE) tftpboot-compact.img
	$(MAKE) tftpboot-idepci.img
	$(MAKE) tftpboot-bf2.4.img
else 
ifeq ($(architecture), m68k)
	$(MAKE) resc1440atari.bin driversatari.tgz
	$(MAKE) resc1440amiga.bin driversamiga.tgz
	$(MAKE) resc1440mac.bin driversmac.tgz
	$(MAKE) resc2880bvme6000.bin resc1440bvme6000.bin driversbvme6000.tgz
	$(MAKE) resc1440mvme16x.bin driversmvme16x.tgz
	$(MAKE) resc1440mvme147.bin driversmvme147.tgz
else 
ifeq ($(architecture), powerpc)
	$(MAKE) resc1440apus.bin driversapus.tgz
	$(MAKE) resc1440chrp.bin driverschrp.tgz
#	$(MAKE) resc1440mbx.bin driversmbx.tgz
	$(MAKE) resc1440pmac.bin driverspmac.tgz
	$(MAKE) resc2880newpmac.bin driversnewpmac.tgz
	$(MAKE) resc1440prep.bin driversprep.tgz bootprep.bin
#-----------------------------------------------------
#	$(MAKE) tftpboot-apus.img root.tar.gz
#	$(MAKE) tftpboot-chrp.img root.tar.gz
#	$(MAKE) tftpboot-mbx.img root.tar.gz
#	$(MAKE) tftpboot-pmac.img root.tar.gz
#	$(MAKE) tftpboot-prep.img root.tar.gz
else
ifeq ($(architecture), sparc)
	$(MAKE) resc1440sun4cdm.bin resc1440sun4u.bin
	$(MAKE) driverssun4cdm.tgz driverssun4u.tgz
	$(MAKE) tftpboot root.tar.gz
else
ifeq ($(architecture), alpha)
	mkdir -p $(alpha_milo_dir)
	for f in alcor xl xlt book1 avanti cabriolet			\
		eb164 eb64p eb66 eb66p lx164 miata mikasa noname pc164	\
		p2k ruffian sx164 takara; do				\
	    [ -f $(alpha_milo_dir)/milo-$(milo_version)-$$f ]		\
		|| (cd $(alpha_milo_dir)				\
			&& wget $(milo_url)/milo-$(milo_version)-$$f )  \
		|| exit 1;						\
	done
# this is spelled out because for 2.2-18, subarch names don't fit
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-alcor	milo_alcor
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-xl	milo_xl
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-xlt	milo_xlt
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-book1	milo_book1
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-avanti	milo_avanti
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-cabriolet	milo_cabriolet
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-eb164	milo_eb164
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-eb64p	milo_eb64p
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-eb66	milo_eb66
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-eb66p	milo_eb66p
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-lx164	milo_lx164
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-miata	milo_miata
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-mikasa	milo_mikasa
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-noname	milo_noname
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-pc164	milo_pc164
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-p2k	milo_p2k
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-ruffian	milo_ruffian
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-sx164	milo_sx164
	ln -sf $(alpha_milo_dir)/milo-$(milo_version)-takara	milo_takara

	[ -f $(alpha_tools_dir)/linload.exe ] || \
	    ( cd $(alpha_tools_dir) && wget $(alpha_linload_url) )
	[ -f $(alpha_tools_dir)/ldmilo.exe ] || \
	    ( cd $(alpha_tools_dir) && wget $(alpha_ldmilo_url) -O ldmilo.exe )

	ln -sf $(alpha_tools_dir)/linload.exe
	ln -sf $(alpha_tools_dir)/ldmilo.exe

ifneq ($(alpha_apb_arches),)
	[ -f $(alpha_apb_dir)/apb.exe -a -f $(alpha_apb_dir)/up1000.pal ]  \
	    || ( mkdir -p $(alpha_apb_dir); cd $(alpha_apb_dir);	   \
		 wget $(alpha_apb_url) -O -				   \
		     | tar -xz apb.exe up1000.pal README.txt install.txt )

	ln -sf $(alpha_apb_dir)/apb.exe .
	ln -sf $(alpha_apb_dir)/up1000.pal .
	for i in $(alpha_apb_dir)/*.txt; do \
	    ln -sf $$i apb_$$(basename $$i); \
	done
endif
	$(MAKE) $(alpha_rescue_targets) $(alpha_drivers_targets) $(alpha_milo_targets)
ifeq ($(alpha_build_bootp),YES)
	$(MAKE) tftpboot.img root.tar.gz
endif
else
ifeq ($(architecture), arm) 
	for subarch in $(arm_arches); do \
		$(MAKE) kernel-$$subarch drivers$$subarch.tgz \
			rescue$$subarch.bin root$$subarch.bin; \
	done
	for subarch in $(arm_arches_tftp); do \
		$(MAKE) tftpboot-$$subarch.img; \
	done
	for subarch in $(arm_arches_nfsroot); do \
		$(MAKE) root$$subarch.tar.gz; \
	done
else
ifeq ($(architecture), ia64)
	$(MAKE) rootmckinley-smp.bin resc10000mckinley-smp.bin driversmckinley-smp.tgz
else
ifeq ($(architecture), mips)
	$(MAKE) addinitrd \
		driversr4k-ip22.tgz resc1440r4k-ip22.bin \
		tftpboot-r4k-ip22.img rootr4k-ip22.tar.gz
		 
else
ifeq ($(architecture), mipsel)
	$(MAKE) rootr4k-kn04.bin rootr4k-kn04.tar.gz
	$(MAKE) driversr4k-kn04.tgz resc1440r4k-kn04.bin resc2880r4k-kn04.bin
	$(MAKE) rootr3k-kn02.bin rootr3k-kn02.tar.gz
	$(MAKE) driversr3k-kn02.tgz resc1440r3k-kn02.bin resc2880r3k-kn02.bin
	# $(MAKE) -C mips-specials addinitrd
	# addinitrd does not work with most DECstation firmware revisions
else
ifeq ($(architecture), hppa)
	$(MAKE) resc288032.bin drivers32.tgz
	$(MAKE) resc288064.bin drivers64.tgz
else
ifeq ($(architecture), s390)
	$(MAKE) s390extras
	$(MAKE) roots390.bin roots390.tar.gz
	$(MAKE) resc2880s390.bin driverss390.tgz
	$(MAKE) linuxs390-tape
else
	echo unsupported architecture: $(architecture); false
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif
ifeq ($(USE_LANGUAGE_CHOOSER),true)
	$(MAKE) xlp.tgz
endif

release/README.txt: README-Users.m4
#	 make the top-level README
	[ -d release ] || mkdir release
	m4 --define=ARCHITECTURE=$(architecture) \
	   --define=RELNAME=$(debname) \
		$< > $@

release/READ-%.txt: README-Users.%.m4
#	 make the top-level README in any language
	[ -d release ] || mkdir release
	m4 --define=ARCHITECTURE=$(architecture) \
	   --define=RELNAME=$(debname) \
		$< > $@

.PHONY: release
release:	build docs
ifeq ($(architecture),alpha)
	./release.sh $(architecture) $(debname) $(debianversion) $(alpha_arches)	
else
ifeq ($(architecture),sparc)
	./release.sh $(architecture) $(debname) $(debianversion) $(generic_rootdisk_no_wildcard)
else
ifeq ($(architecture),arm)
	TOOLS_DIR=$(tools_dir) arm_arches="$(arm_arches)" arm_arches_tftp="$(arm_arches_tftp)" arm_arches_nfsroot="$(arm_arches_nfsroot)" arm_arches_rootbin="$(arm_arches_rootbin)" arm_arches_linux="$(arm_arches_linux)" ./release.sh $(architecture) $(debname) $(debianversion)
else
	TOOLS_DIR=$(tools_dir) ./release.sh $(architecture) $(debname) $(debianversion)
endif
endif
endif

.PHONY: umount
umount:
	-for d in ${tmpdir}/boot-floppies/mnt.*; do umount $$d; done;
#	 also need to unmount /dev/pts and /proc in base-tmp
#	 directories if the build was interrupted
	-find ${tmpdir}/boot-floppies -path '*/dev/pts' -o -path '*/proc' \
		-a -type d | xargs -r umount

.PHONY: cleanfiles
cleanfiles:
	rm -f *.bin *.tgz sys_map*.gz config*.gz linux* modcont* core	\
		root*.tar.gz *.img *.tmp *.o *.iso $(SFONT) xlp.tgz
	rm -f `find -name \*~` disks-$(architecture)
	rm -f `find -name '.#*'`
	rm -rf release updates

.PHONY: clean
clean:	cleanfiles
	set -e; for dir in utilities scripts/rootdisk/messages documentation \
			   powerpc-specials mips-specials s390-specials ; \
		do \
		    $(MAKE) -C $$dir $@ ;\
		done
	$(ROOTCMD) $(MAKE) umount
	$(ROOTCMD) rm -rf $(tmpdir)/boot-floppies
# and drop the tarball with device files
#	rm -rf devtarball.tgz

.PHONY: cleanarchive
cleanarchive:
	$(ROOTCMD) rm -rf $(archive)

.PHONY: distclean
distclean:	clean cleanarchive
	$(MAKE) -C utilities distclean
	$(MAKE) -C documentation distclean

include make/keymaps
include make/modules
include make/checks
include make/root
include make/rescue
include make/drivers
include make/tftp
include make/utils

##
## optional file with special rules for this architecture
##
-include make/$(architecture).rules

sign:
	pgp +clearsig=on -fast <release/md5sum.txt >release/md5sum.tmp
	mv release/md5sum.tmp release/md5sum.txt

=== documentation/Makefile ===
# Makefile for documentation
# 
# See README-authors for more information.

.SUFFIXES:

-include ../config
-include Makefile.docs

# whether documentation should be installed in subdirs;
# see install-langs target
INSTALLSTYLE	?= subdir

# fdisk documentation to include (varies per platform)
FDISK_DOCS := $(shell grep -s "fdisk\|fdasd\|dasdfmt\|parted" \
		../scripts/rootdisk/SMALL_BASE_LIST_$(architecture) | \
		sed -e 's/^.*\/\(.*\)/\1.txt/' 2>/dev/null)

# set extension of source/dest files based on LINGUA
ifeq ($(LINGUA),C)
SRCEXT		:=
DESTEXT		:= .en
DESTDIRADD	:=
else
SRCEXT		:= .$(LINGUA)
DESTEXT		:= .$(LINGUA)
DESTDIRADD	:= $(LINGUA)
endif

# programs for creating output
DDOC		:= /usr/share/sgml/debiandoc/dtd/sgml/1.0/debiandoc.dcl
DEBIANDOC2HTML	:= debiandoc2html -d $(DDOC) -l $(LINGUA) -c 
DEBIANDOC2PS	:= debiandoc2ps -d $(DDOC) -l $(LINGUA)
DEBIANDOC2TEXT	:= debiandoc2text -d $(DDOC) -l $(LINGUA) 
DEBIANDOC2LATEX	:= debiandoc2latex -d $(DDOC) -l $(LINGUA)

# detailed sgml validation
NSGMLS		:= nsgmls -ges -wall $(DDOC)

# maximum times we're willing to run TeX to get cross-references right, if you subtract by 3
MAX_TEX_RECURSION	:= 6

# documents to build
TARGETDOCS := index.en.html			\
	      install$(DESTEXT).txt		\
	      install$(SRCEXT).html/install$(DESTEXT).html \
	      $(FDISK_DOCS)

ifneq "$(findstring $(LINGUA),$(dselect-beginner-langs))" ""
TARGETDOCS += dselect-beginner$(SRCEXT).html/dselect-beginner$(DESTEXT).html \
	      dselect-beginner$(DESTEXT).txt
endif

# you might want to remove this if it is failing for you
#   ja and ru documents are currently not converted into .pdf correctly 
ifneq ($(LINGUA),ja)
ifneq ($(LINGUA),ru)
TARGETDOCS	+= install$(DESTEXT).pdf
endif
endif

EXTRAFILES	:= officiallogo-nd-50.jpg openlogo-nd-50.jpg

# just an unreasonable default
DESTDIR		:= /tmp

ifeq ($(OFFICIALWEBBUILD),true)
# special build requirements for web building
install_file 	:= install -m 2664 -p
makedir		:= mkdir -m 2775
else
install_file	:= install -m 644 -p
makedir		:= mkdir -m 0755
endif

DEB_VERSION	:= $(shell cd .. && LC_ALL=C dpkg-parsechangelog |	\
			grep '^Version: ' | sed 's/^Version: *//')

# default date representation in documents
DATEFORM_$(LINGUA) := %d %B, %Y
# exceptions from the above rule:
DATEFORM_hr	:= %-d. %-m. %Y.
DATEFORM_de	:= %-d. %b. %Y

DATE		:= $(shell cd .. && date --date="`dpkg-parsechangelog |	\
			grep '^Date: ' | sed 's/^Date: *//'`" 		\
			'+$(strip $(DATEFORM_$(LINGUA)))')

# derived entity files
DERIVED_ENTS	:= messages.ent dynamic.ent
# this for is used for dependencies
ENT_DEPENDS	:= defaults.ent messages.ent dynamic.ent

define checklingua
  if [ -z "$(LINGUA)" ]; then \
  echo LINGUA variable is not set -- see documentation/README-authors; \
  exit 1; \
  fi
endef

# actual rules start here
# (note: default rule is the default one from Makefile.docs, not this one)
.PHONY:	all
all:	supplemental_makefile $(TARGETDOCS) $(EXTRATARGETDOCS)

.PHONY: lint
lint:	$(ENT_DEPENDS)
ifneq "$(wildcard install$(SRCEXT).sgml)" ""
	@echo "Verifying SGML validity for Installation Manual, language $(LINGUA):"
	$(NSGMLS) install$(SRCEXT).sgml
#	@echo "Checking for deprecated entity references:"
#	nsgmls -oentity /usr/lib/sgml/declaration/debiandoc.decl \
#	  install$(SRCEXT).sgml 2>/dev/null | sed -e '/^IMSG/!d' -e 's/^I/   /'
endif
ifneq "$(wildcard dselect-beginner$(SRCEXT).sgml)" ""
	@echo "Verifying SGML validity for dselect Documentation for Beginners, language $(LINGUA):"
	$(NSGMLS) dselect-beginner$(SRCEXT).sgml
endif
ifneq "$(wildcard release-notes$(SRCEXT).sgml)" ""
	@echo "Verifying SGML validity for Release Notes, language $(LINGUA):"
	$(NSGMLS) release-notes$(SRCEXT).sgml
endif

.PHONY:	validate
validate:	$(ENT_DEPENDS)
	@set -ex; for i in *.sgml; do $(NSGMLS) $$i; done

.PHONY:	supplemental_makefile
supplemental_makefile:
	@$(checklingua)
	@[ ! -f $(LINGUA)/Makefile ] || $(MAKE) -C $(LINGUA)

# generate the nice index page.
# FIXME: is m4 really the right way to do this?
ifneq "$(wildcard index$(DESTEXT).html.m4)" ""
index$(DESTEXT).html: index$(DESTEXT).html.m4; m4 \
 --define=ARCHITECTURE=${architecture} \
 --define=OFFICIAL=${OFFICIALWEBBUILD} \
    $< > $@
else
.PHONY: index$(DESTEXT).html index.en.html
endif

# this will probably only work if your name is "Adam Di Carlo"
.PHONY: ChangeLog
ChangeLog:
	cvs2cl.pl --tags --branches --revisions --utc	\
	  --usermap $$HOME/debian/boot-floppies/CVSROOT/users

# generic rules for all the languages and output formats -- Installation Manual.
ifneq "$(wildcard install$(SRCEXT).sgml)" ""
install$(SRCEXT).html/install$(DESTEXT).html:	install$(SRCEXT).sgml	\
						$(ENT_DEPENDS)
	$(DEBIANDOC2HTML) -t install $<

install$(DESTEXT).txt:	install$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2TEXT) -O $< > $@

install$(DESTEXT).ps:	install$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2PS) -O $< > $@

install$(DESTEXT).tex:	install$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2LATEX) -O $< > $@
else
.PHONY: install$(SRCEXT).html/install$(DESTEXT).html install$(DESTEXT).txt \
        install$(DESTEXT).ps install$(DESTEXT).tex install$(DESTEXT).pdf
endif

# generic rule for all the PDFs
%.pdf:	%.tex
#	 note that I have seen bi-stable .aux files, thus we check two levels deep
	-cp -pf prior.aux pprior.aux 2>/dev/null
	-cp -pf $(basename $<).aux prior.aux 2>/dev/null
#	 fail if we don't have pdflatex correctly installed
	kpsewhich pdflatex.fmt >/dev/null
#	 due to a bug in debiandoc2latex2e output, this might fail
	-pdflatex '\nonstopmode\input{$<}' >/dev/null # see $(@:.pdf=.log) for details
	@set -e								;\
	if ! cmp $(basename $<).aux prior.aux 2>/dev/null &&		\
	   ! cmp $(basename $<).aux pprior.aux 2>/dev/null; then	\
		if expr $(MAKELEVEL) '<' $(MAX_TEX_RECURSION) >/dev/null;\
		then							\
		   echo "remaking $@ (take $(MAKELEVEL))"		;\
		   rm -f $@						;\
		   $(MAKE) $@						;\
		else							\
		   echo "E: $@ needs remaking, but we have reached max. level, $(MAX_TEX_RECURSION)" ;\
		fi							\
	fi
	rm -f prior.aux pprior.aux

# generic rules for all the languages and output formats -- dselect Documentation for Beginners
ifneq "$(wildcard dselect-beginner$(SRCEXT).sgml)" ""
dselect-beginner$(SRCEXT).html/dselect-beginner$(DESTEXT).html:		\
		dselect-beginner$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2HTML) -t dselect-beginner $<

dselect-beginner$(DESTEXT).txt:	dselect-beginner$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2TEXT) -O $< > $@

dselect-beginner$(DESTEXT).ps:	dselect-beginner$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2PS) $<

dselect-beginner$(DESTEXT).tex:	dselect-beginner$(SRCEXT).sgml $(ENT_DEPENDS)
	$(DEBIANDOC2LATEX) -O $< > $@
else
.PHONY: dselect-beginner$(SRCEXT).html/dselect-beginner$(DESTEXT).html \
        dselect-beginner$(DESTEXT).txt dselect-beginner$(DESTEXT).ps \
        dselect-beginner$(DESTEXT).tex dselect-beginner$(DESTEXT).pdf
endif

# these rules generate text files out of *fdisk programs' manpages
cfdisk.txt:
	./man2text $(ftp_archive) cfdisk 8 util-linux > $@

cfdisk-utf8.txt: cfdisk.txt
	cp -a cfdisk.txt cfdisk-utf8.txt

fdisk.txt:
	./man2text $(ftp_archive) fdisk 8 util-linux > $@

atari-fdisk.txt:
	./man2text $(ftp_archive) atari-fdisk 8 atari-fdisk > $@

amiga-fdisk.txt:
	./man2text $(ftp_archive) amiga-fdisk 8 amiga-fdisk > $@

mac-fdisk.txt:
	./man2text $(ftp_archive) mac-fdisk 8 mac-fdisk > $@

pmac-fdisk.txt:
	./man2text $(ftp_archive) pmac-fdisk 8 pmac-fdisk-cross > $@

dasdfmt.txt:
	./man2text $(ftp_archive) dasdfmt 8 s390-tools > $@

fdasd.txt:
	./man2text $(ftp_archive) fdasd 8 s390-tools > $@

parted.txt:
	./man2text $(ftp_archive) parted 8 parted > $@

.PHONY: install
install:
	set -e								;\
	for lang in $(installmanual-langs); do				 \
	    echo "installing $$lang"					;\
	    $(MAKE) LINGUA=$$lang install-lang				;\
	done
ifeq ($(OFFICIALWEBBUILD),true)
#	setting our nice content-negotiation symlinks
	set -e								;\
	for file in `find $(ALLARCHINSTALLDIR)/$(architecture) -name '*.en.*'`; do	 \
	    ln -sf `basename $$file` `echo $$file | sed -e 's/\.en//'`	;\
	done
endif

.PHONY:	install-lang
install-lang:
	[ -d $(DESTDIR) ] || $(makedir) -p $(DESTDIR)
ifneq ($(INSTALLSTYLE),subdir)
#	install all langs files into one directory
	$(install_file) $(TARGETDOCS) $(EXTRAFILES)			 \
		$(wildcard dselect-beginner$(SRCEXT).html/*		 \
		install$(SRCEXT).html/*) $(DESTDIR)
else		# subdirectory install, to make things easier to find
	for doc in $(TARGETDOCS) $(EXTRAFILES)				 \
		$(wildcard dselect-beginner$(SRCEXT).html/* 		 \
		install$(SRCEXT).html/*); do				 \
	    $(makedir) -p $(DESTDIR)/$(DESTDIRADD)				;\
	    $(install_file) $$doc $(DESTDIR)/$(DESTDIRADD)		;\
	done
#	make index.html symlink to index.??.html for all subdirs
	set -e								;\
	for file in `find $(DESTDIR) -name 'index.??.html'`; do		 \
	    ln -sf `basename $$file`					 \
		   `echo $$file | sed -e 's/\...\.html/.html/'`		;\
	done
endif

.PHONY:	clean
clean:
	rm -f $(DERIVED_ENTS) dynamic_*.ent messages*.ent
	rm -rf *.html
	rm -f *.txt *.tex *.dvi *.pdf *.ps
	rm -f *.log *.aux *.bak *.out *.sasp* *.toc
	rm -f doc.stamp
	set -e ; for dir in `find . -type d -mindepth 1 -maxdepth 1`; do \
	    [ ! -f $$dir/Makefile ] || $(MAKE) -C "$$dir" $@		;\
	done

.PHONY:	distclean
distclean: clean
	rm -f *~ *.orig \#*
	rm -rf $(ALLARCHINSTALLDIR)
	rm -rf upgrade-*
	rm -f relnotes.tar.bz2

##
## upload docs to http://www.debian.org/releases/...
##
# this will only work if you're in the debwww group on localhost and on www-master
mirror-to-master:
	@[ -d $(ALLARCHINSTALLDIR) ] || { echo "Run make (uni-)doc-web first!"; exit 1; }
	chgrp -R debwww $(ALLARCHINSTALLDIR)
	find $(ALLARCHINSTALLDIR) -type f | xargs chmod 0664
	find $(ALLARCHINSTALLDIR) -type d | xargs chmod g+sw
	rsync -rltDpgvz --rsh ssh $(ALLARCHINSTALLDIR)/		\
	  www-master.debian.org:/org/www.debian.org/www/releases/$(debname)/


# generate entities which are dynamically defined by the settings of this
# build run, generally set in the top-level config file
dynamic_$(LINGUA)_$(architecture).ent: ../debian/changelog
ifeq "$(architecture)" ""
	@echo architecture variable is not set -- see documentation/README-authors
	exit 1
endif
ifeq "$(findstring $(architecture), $(arches))" ""
	@echo architecture variable is set to something strange, edit ../config
	exit 1
endif
	: > $@			# clear the file
	echo "<!entity docversion       \"$(DEB_VERSION)\">" >> $@
	echo "<!entity docdate          \"$(DATE)\">" >> $@
	echo "<!entity language         \"$(LINGUA)\">" >> $@
	echo "<!entity langext          \"$(DESTEXT)\">" >> $@
	echo "<!entity release          \"$(debianversion)\">" >> $@
	echo "<!entity releasename      \"$(debname)\">" >> $@
	echo "<!entity kernelversion    \"$(kver)\">" >> $@
	echo "<!entity altkernelversion \"$(altkver)\">" >> $@
	echo "<!entity architecture     \"$(architecture)\">" >> $@
	echo "<!entity % $(architecture) \"INCLUDE\">" >> $@
	echo "<!entity % lang-$(LINGUA) \"INCLUDE\">" >> $@
	set -e; for i in $(FDISK_DOCS); do			    \
		echo "<!entity % $$i    \"INCLUDE\">" >> $@;\
	done
ifeq ($(OFFICIALWEBBUILD),true)
	echo "<!entity % official-web-build \"INCLUDE\">" >> $@
	echo "<!entity path-to-top-level \"\">" >> $@
else
	echo "<!entity % official-web-build \"IGNORE\">" >> $@
# figure out how we get to the top level, for downloadable-files
# entity in defaults.ent; non-English goes into a subdir in docs so we
# need to allow for that
ifeq ($(INSTALLSTYLE),subdir)
ifeq ($(LINGUA),C)
	echo "<!entity path-to-top-level \"../\">" >> $@
else
	echo "<!entity path-to-top-level \"../../\">" >> $@
endif
else
	echo "<!entity path-to-top-level \"\">" >> $@
endif
endif

.PHONY: dynamic.ent
dynamic.ent:	dynamic_$(LINGUA)_$(architecture).ent
	rm -f $@
	ln -s $< $@

# in case LINGUA isn't set, give a decent err message
$(DBOOTSTRAP_DIR)/po/.po:
	@$(checklingua)

# unlike its translations, C.po isn't static, it's autogenerated
$(DBOOTSTRAP_DIR)/po/C.po:
	$(MAKE) -C $(DBOOTSTRAP_DIR)/po C.po

=== mips-specials/Makefile ===
#
# This file is subject to the terms and conditions of the GNU General Public
# License.  See the file copyright in the debian subdirectory of this archive
# for more details.
#
# Copyright (C) 2001 by Guido Guenther
#
# this is based on the arch/mips/boot/Makefile in the kernel sources

CC := gcc
CFLAGS := -Wall -Werror -pipe -O2

addinitrd: addinitrd.c
	$(CC) -o $@ $^

clean:
	rm -f addinitrd

=== utilities/dbootstrap/Makefile ===
# Makefile for dbootstrap
#
# Yes, we like rewriting this makefile over and over again....

# Some things we can set to change compilation:
# DEBUG=true	- turns on debugging (-g)
# SMALL=true	- turns on size optimizations (-Os -fomit-frame-point)
# LC=true	- turns on language chooser
#		  do NOT use USE_LANG_CHOOSER, we need to be able to
#		  flip it on and off
# FB=true	- turns on "graphical" verson of dbootstrap
# EFENCE=true	- compile with efence
# POINTERIZE=false = turns off translations

-include ../../config

# These are the default values:
DEBUG	?= false
SMALL	?= true
LC = $(USE_LANGUAGE_CHOOSER)
FB	?= false
EFENCE	?= false
POINTERIZE ?= true
LINGUA	?= C
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
DEBUG	:= false
SMALL	:= false
endif

# General compiler stuff
CC	 := gcc
CFLAGS	 := -Wall -D_GNU_SOURCE -pipe -I. $(EXTRA_CFLAGS) 
LDFLAGS	 :=
BFLIBS	 := ../libfdisk/libfdisk.a
LIBS	 := -lloadtrm $(BFLIBS) -lnewt -lslang
ifeq ($(LC),true)
BUILD	 := build-lc/
else
BUILD	 := build/
endif

ifeq ($(DEBUG),true)
CFLAGS	+= -g -DDEBUG
LDFLAGS	+=
STRIP	:= :
else
ifeq ($(SMALL),true)
CFLAGS	+= -Os -fomit-frame-pointer -fno-builtin
LDFLAG	+=
STRIP	:=  strip --remove-section=.note --remove-section=.comment
else
CFLAGS	+= -O2
STRIP	:= :
endif
endif

# for euc-jp encoded japanese string
ifeq ($(LINGUA),ja)
USE_SHRINK_STRING = true
endif
ifdef USE_SHRINK_STRING
CPPFLAGS	+= -DUSE_SHRINK_STRING
OBJECT_SS	+= shrink_string.o
endif

ifeq ($(EFENCE),true)
LIBS	+= -lefence
endif

ifeq ($(LC),true)
CFLAGS	+= -DUSE_LANGUAGE_CHOOSER -DUSE_LANGUAGE_VARIANTS -DUTF8
endif

ifdef KBD
CFLAGS += -DKBD=\"$(KBD)\"
endif

ifeq ($(FB),true)
CFLAGS	+= -DGRAPHICAL
LIBS	+= /usr/lib/libbogl.a
endif

# constants
ifeq ($(LC),true)
DBOOTSTRAP	:= dbootstrap-lc
else
DBOOTSTRAP	:= dbootstrap
endif
BUILDTIME	:= $(shell TZ=UTC date --utc "+%Y.%m.%d-%H:%M%z")
ifndef KERNEL_VERSION_CODE
# fake it... (2.2)
KERNEL_VERSION_CODE := $(shell echo $$((2 * 65535 + 2 * 256)))
endif

CFLAGS	+= -DBUILDTIME='"$(BUILDTIME)"' -DARCHNAME='"$(architecture)"'
CFLAGS	+= -DKERNEL_VERSION_CODE=${KERNEL_VERSION_CODE} -DKVER='"${KVER}"'
ifdef FONT
CFLAGS	+= -DFONT='"$(FONT)"'
endif

# Default build target:
all: $(DBOOTSTRAP) po/po_stamp

# Targets
DBOOTSTRAP_MODULES	:= $(subst .c,,$(wildcard *.c))
TEST_MODULES		:= interactive_shell	\
			   boxes		\
			   release_notes	\
			   main_menu		\
			   kbdconfig		\
			   choose_medium	\
			   floppy_merge		\
			   pcmcia		\
			   netconfig		\
			   tzconfig		\
			   partition_config	\
			   select_not_mounted	\
			   bootconfig		\
			   reboot_system	\
			   net-fetch

ifeq ($(POINTERIZE),false)
SRCEXT			:= c
OBJEXT			:= o
else
SRCEXT			:= t.c
OBJEXT			:= to
LANG_H			:= lang.h
endif
DBOOTSTRAP_TARGETS	= $(addprefix $(BUILD),$(addsuffix .$(OBJEXT),$(DBOOTSTRAP_MODULES)))
TEST_TARGETS		= $(addprefix $(BUILD),$(addsuffix .$(OBJEXT),$(TEST_MODULES)))

ifeq ($(LC),true)
DBOOTSTRAP_TARGETS += langs/langs.o
langs/langs.o:
	$(MAKE) -C langs
endif

# Rules
ifneq ($(BUILD),)
$(BUILD):
	@test -d $(BUILD) || mkdir -p $(BUILD)
endif

show_settings:
	@echo Compilation settings:
	@echo CC	= $(CC)
	@echo CFLAGS	= $(CFLAGS)
	@echo LDFLAGS	= $(LDFLAGS)
	@echo LIBS	= $(LIBS)
	@echo BUILD	= $(BUILD)
	@echo DEBUG	= $(DEBUG)
	@echo SMALL	= $(SMALL)
	@echo LC	= $(LC)
	@echo FB	= $(FB)
	@echo EFENCE	= $(EFENCE)
	@echo POINTERIZE = $(POINTERIZE)
	@echo LINGUA	= $(LINGUA)

# i18n stuff
po/po_stamp:
	make -C po

po/%:
	make -C po $(notdir $@)

$(OBJECT_SS) :
	$(MAKE) -C shrink_string LINGUA="$(LINGUA)"

# libraries
$(BFLIBS):
	$(MAKE) -C $(dir $@) $(notdir $@)

# object build rules
# Generate dependencies (these are included at the end of this file 
$(BUILD)%.d: %.c
	gcc -MM $(CFLAGS) $< | sed -e "1s/.*:/$(subst /,\\/,$@):/" > $@

# Translations...
$(BUILD)%.t.c: %.c po/$(LINGUA).mo
	@echo "#line 1 \"$<\"" > $@
	pointerize -m po/$(LINGUA).mo -m po/C.mo < $< >> $@

$(BUILD)%_test.$(OBJEXT): CFLAGS += -D_TESTING_
$(BUILD)%_test.$(OBJEXT): $(BUILD)%.$(SRCEXT) $(BUILD)%.d $(LANG_H)
	$(CC) $(CFLAGS) -c -o $@ $<

$(BUILD)%.$(OBJEXT): $(BUILD)%.$(SRCEXT) $(BUILD)%.d $(LANG_H)
	$(CC) $(CFLAGS) -c -o $@ $<

lang.h: po/C.mo
	gen-header $<
	echo >> $@

test.trm: po/$(LINGUA).trm
	cp $^ $@

# dbootstrap and dbootstrap_test
$(BUILD)$(DBOOTSTRAP)_test: CFLAGS += -D_EXETESTING_
$(BUILD)$(DBOOTSTRAP) $(BUILD)$(DBOOTSTRAP)_test: $(BUILD) $(DBOOTSTRAP_TARGETS) $(BFLIBS)
	$(CC) -o $@ $(DBOOTSTRAP_TARGETS) $(LDFLAGS) $(LIBS)
	$(STRIP) $@

# unit test targets, e.g. main_menu_test
$(BUILD)%_test: $(BUILD) $(BUILD)main_test.$(OBJEXT) \
	$(BUILD)%_test.$(OBJEXT) $(DBOOTSTRAP_TARGETS) test.trm
	$(CC) -o $@ $(BUILD)main_test.$(OBJEXT) $(BUILD)$*_test.$(OBJEXT) \
		$(filter-out $< $(BUILD)main.$(OBJEXT) $(BUILD)$*.$(OBJEXT),$(DBOOTSTRAP_TARGETS)) $(LDFLAGS) $(LIBS)
	$(STRIP) $@

# this is just for convenience to move things from the build directory
# back to the source (this is meant only for the final target, not the intermediates)

ifneq ($(BUILD),)
%: $(BUILD)%
	cp $(BUILD)$@ $@
endif

# Clean rules
.PHONY: clean
clean:
	$(MAKE) -C po $@
	$(MAKE) -C langs $@
	rm -f $(DBOOTSTRAP) $(BUILD)$(DBOOTSTRAP) *_test dbootstrap-lc
	rm -f $(BUILD)*.o $(BUILD)*.to $(BUILD)*.t.c $(BUILD)*_test $(BUILD)*.d

distclean: clean
	$(MAKE) -C po $@
	$(MAKE) -C langs $@
	rm -f lang.h test.trm C.mo kbddefault.h
	test -z "$(BUILD)" || rm -rf $(BUILD)

.PHONY: all all_potato all_woody clean distclean

The_DFiles = $(wildcard $(BUILD)*.d)
ifneq ($(words $(The_DFiles)),0)
include $(The_DFiles)
endif

$(DBOOTSTRAP):	$(BUILD)$(DBOOTSTRAP)

=== debian/changelog ===
boot-floppies (3.0.22) unstable; urgency=low

  * Adam Di Carlo:
    - documentation updates & link corrections; i386 references to  ide
      flavor removed, bf2.4 added; sparc references to removed sun4dm-pci
      subarch removed
    - fix broken docs/*fdisk.txt which are generated from man pages;
      closes: #137570
    - fix build-depends-indep-without-arch-indep
    - review all the stuff in docs/defaults.ent relating to images,
      flavors, files, etc.  There were a number of missing stuff relevant
      to lart, subarches mentioned which no longer exists, etc.
      closes: #138591, #138588, #138594
    - doc: i386 supports tftp
  * Eduard Bloch
    - fixed filesystem choice while creating of the boot-floppies on i386
    - German translation updates
    - bootconfig.c corrections to work on ATARAID
    - changed extract_base's progress box to not tell users to debug
    - changed syslinux.cfg template to work properly with non-linux.bin
      profiles, replaced linux.bin references in the messages files.
      Closes:#139786, #140264
    - PERL_BADLANG=0 before extract_base, suppress the locale warnings,
      closes: #138468
    - added USB modules to root floppy on bf2.4, closes: #139595
  * Chris Tillman
    - added note about vc4 usage in rescue-boot.sgml
    - use fdisk references in defaults.ent, not urls.ent
    - fix mipsel handling of driver floppies (copied mips code)
    - fix defaults.ent problems
    - update docs for new-powermac
    - add list of verbose/quiet effects to appendix
    - add test for Release file before calling debootstrap, 
      Closes: #132838, #136639
    - update install manual for m68k, arm
    - add table of task sizes in appendix
    - correct newpmac kernel build 1440->2880, causing name confusion
  * Giuseppe Sacco
    - corrected a small problem when identifing the installed locale
  * Mikhail Sobolev
    - Change Apple_Bootstrap messages to avoid redundancy
  * David Kimdon
    - fix French language chooser text
    - fix proxy line for server select box, better formatting when strings
      are different lengths
    - if we try a proxy, find that it doesn't work, then end up
      installing the base system without a proxy we need to set 
      [HTTP|FTP]_PROXY='' in dbootstrap_settings
    - mkreiserfs option changed from -v[1|2] to --format [3.5|3.6] 
      (closes: #139415)
    - remove scripts/rootdisk/messages/[C,ca ... zh_TW]/boot_message since we
      now hold that text in dbootstrap's .po files.
    - add note to translators that they should use only ASCII chars in the
      text to be displayed on the syslinux screen. (closes: #138849)
    - note to translators to keep bootconfig.c MBR messages under one line
      or about 70 characters. (closes: #138679)
    - require bogl-bterm 0.1.9-1 so we get pretty borders on i18n boxes,
      include some graphic fonts, patch from pb (closes: #138653)
  * Tommi Virtanen <tv@debian.org>
    - update swedish.src
  *  Alejandro Lamas <azeta@enterate.org>
    - update spanish.src
  * Junichi Uekawa
    - fs_type_tab[] should be extern (closes: #137748)
    - update dbootstrap Japanese translation
    - make dbootstrap/langs/japanese.src to be shorter
    - config: use ja, instead of pl on the basic floppy set. It should be
      okay, CDROM should have the language.
  * Petter Reinholdtsen
    - updated LC menu entry for Norwegian (applied by blade)
  * Claus Hindsgaul
    - Danish updates
    - Chinese zh_CN.po update thanks to malix <malixren@yahoo.com>
  * Karsten Merker
    - release.sh: remove garbage (side effect of the linux -> linux.bin
      transition) in $release for mipsel
    - documentation/da/inst-methods.sgml: fixed sgml error
  * Ren Weili
    - Chinese translation updates
  * Matt Kraai
    - avoid segfault during `Initialize a Linux Partition' on powerpc/apus;
      closes: #138799
    - look for netwinder rescue image in images-2.88;
      closes: #139041
  * Jordi Mallach
    - dbootstrap Catalan translation updates
    - Catalan manual and release-notes updates
    - release-notes Catalan translation by Ivan Vilata i Balaguer
    - updates to the Catalan install manual by Antoni Bella
  * Richard Hirst
    - ia64: warn if someone tries to manipulate a GPT partitioned disk
      with cfdisk
    - default fs_type to auto for any arch that doesn't explicitly specify
      it in write_boot_floppy()
    - ia64: add documentation for parted
  * Josip Rodin
    - update croatian.src
  * Colin Walters
    - bump new-powermac kernel version to 2.4.18
    - Minor english fixes in dbootstrap.
  * Steve Langasek <vorlon@debian.org>
    - update czech.src
  * Andreas Wst <andiw@pop.agri.ch>
    - update release_notes.de (closes: #140700)

 -- Adam Di Carlo <aph@debian.org>  Fri, 15 Mar 2002 01:18:26 -0500

boot-floppies (3.0.21) unstable; urgency=medium

  * Adam Di Carlo
    - we now build against Woody

      THIS IS A SERIOUS CHANGE but required for Woody release.
      If packages from unstable are needed, you will need to copy those to
      localdir as configured in `config'

    - sparc uses libc 2.2.5 now
    - sparc/sun4u kernel uses 2.4.18 (thanks BenC)
    - sparc doesn't have sun4dm-pci anymore, no one needs it (thanks BenC)
    - EXTRACT-i18n was pulling in for all arches cfdisk-utf8, which would
      break sparc build
    - package searching in 'archive' dir (where downloads go) is sensitive
      to the current architecture, making it safe to share the download dir
      for multiple arch builds if desired
  * Giuseppe Sacco
    - new maintainer for the italian translation
    - updated scripts/rescue/messages/it/*
    - updated utilities/dbootstrap/po/it.po
    - translated README-Users.it.m4
  * Richard Hirst
    - fix inverted test on USE_LANGUAGE_CHOOSER in rootdisk.sh
    - ia64: turn on USE_LANGUAGE_CHOOSER
    - ia64: move vars from make/ia64.rules to make/ia64.vars
    - boxes.c, remove redundant cast, caused gcc warning on 64 bit


=== debian/control ===
Source: boot-floppies
Section: devel
Priority: extra
Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Uploaders: Adam Di Carlo <aph@debian.org>, David Kimdon <dwhedon@debian.org>
Standards-Version: 3.1.1
Build-Depends: glibc-pic, slang1-pic (>= 1.4.4-7.2) | slang1-utf8-pic (>= 1.4.4-7.2), libnewt-dev (>= 0.50.17-9.4) | libnewt-utf8-dev (>= 0.50.17-9.4), libnewt-pic (>= 0.50.17-9.4) | libnewt-utf8-pic (>= 0.50.17-9.4), libpopt-dev, zlib1g-dev, recode, gettext, m4, debiandoc-sgml (>= 1.1.53), libi18n-langtags-perl, man-db, libpaperg, tetex-extra, perl5, libwww-perl, locales [i386 arm powerpc alpha], libpng2-dev [i386 arm powerpc alpha], pointerize, libgd-dev, bogl-bterm [i386 arm powerpc alpha], libbogl-dev (>= 0.1.8-1), bison, ash, dpkg-awk, flex, file, debhelper, gawk, python-dev (>= 2.1.1-4), python2.1-xml (>= 0.7-1), bf-utf-source, zlib-bin [i386 arm], dosfstools [powerpc alpha m68k], console-common [arm], vmelilo [m68k], s390-tools [s390], aboot [alpha], wget, kernel-source-2.2.20 [alpha], syslinux [i386], debootstrap, catsboot [arm], zip [arm], bzip2 [powerpc], mips-tools [mips mipsel], makedev (>= 2.3.1-58)

Package: install-doc
Section: doc
Architecture: any
Recommends: www-browser
Description: Documentation for Debian installation and release notes
 Contains documentation for the Debian installation system for this
 architecture.  Files are provided in HTML, ASCII, and PDF format in
 /usr/share/doc/install-doc.  A number of different languages are
 provided.
 .
 The full set of this this information may be found in 
   <URL:http://www.debian.org/releases/>
